#pragma once

#include "../NeMessenger/WorkGroupModel.h"
#include "../NeMessenger/WorkGroupController.h"
#include "../NeMessenger/WorkGroupView.h"
#include "../NeMessenger/WorkGroupActorEvent.h"

// If necessary ...
class MockWorkGroup : public IWorkGroupModel
{
public:
	MockWorkGroup() {};
	virtual ~MockWorkGroup() {};

	MOCK_METHOD1( AddMember, void(const NE_MEMBER_DATA& data) );
	MOCK_CONST_METHOD0( GetMemberVector, const vector<ORG_MEMBER_DATA>() );
	MOCK_METHOD1( GetMember, const NE_MEMBER_DATA(int index) );

	MOCK_METHOD1( AddWorkGroup, void(const GT_ORG_GROUP_DATA& data) );
	MOCK_CONST_METHOD0( GetWorkGroupVector, const vector<GT_ORG_GROUP_DATA>() );

	MOCK_METHOD1( AddOrgGroup, void(const GT_ORG_GROUP_DATA& data) );
	MOCK_CONST_METHOD0( GetOrgGroupVector, const vector<GT_ORG_GROUP_DATA>() );

	MOCK_METHOD0( Clear, void() );
	MOCK_METHOD0( ClearMembers, void() );
	MOCK_METHOD0( ClearGroups, void() );

	MOCK_METHOD2( UpdateMemberStatus, void(LPCWSTR strUserID, GTUserStatusType eUserStatus) );
	MOCK_METHOD2( UpdateMemberIPTStatus, void(LPCWSTR strUserID, NTIPTStatusType eUserIPTStatus) );
	MOCK_METHOD1( GetMemberStatus, GTUserStatusType(LPCWSTR strUserID) );
	MOCK_METHOD1( GetMemberIPTStatus, NTIPTStatusType(LPCWSTR strUserID) );

	MOCK_METHOD1( AddSelectdUser, void( const NE_MEMBER_DATA& data ) );
	MOCK_METHOD0( GetSelectedUserVector, std::vector<ORG_MEMBER_DATA>() );
	MOCK_METHOD0( ClearSelectedUserVector, void() );
};

class CWorkGroupTest : public ::testing::Test
{
public:
	CWorkGroupTest(void);
	virtual ~CWorkGroupTest(void);

protected:
	virtual void SetUp();
	virtual void TearDown();
};
